Index: drivers/filesystems/btrfs/extent-tree.c
===================================================================
--- drivers/filesystems/btrfs/extent-tree.c	(révision 74430)
+++ drivers/filesystems/btrfs/extent-tree.c	(copie de travail)
@@ -1319,12 +1448,26 @@
         
         if (secttbr->offset == tbr->offset) {
             if (ei->refcount == 1) {
-                delete_tree_item(Vcb, &tp, rollback);
-                delete_tree_item(Vcb, &tp2, rollback);
+                Status = delete_tree_item(Vcb, &tp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("delete_tree_item returned %08x\n", Status);
+                    return Status;
+                }
+                
+                Status = delete_tree_item(Vcb, &tp2);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("delete_tree_item returned %08x\n", Status);
+                    return Status;
+                }
+                
                 return STATUS_SUCCESS;
             }
             
-            delete_tree_item(Vcb, &tp2, rollback);
+            Status = delete_tree_item(Vcb, &tp2);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
             
             newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
             if (!newei) {
@@ -1336,11 +1479,16 @@
 
             newei->refcount -= rc;
             
-            delete_tree_item(Vcb, &tp, rollback);
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
             
-            if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
+            Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                return Status;
             }
             
             return STATUS_SUCCESS;
@@ -1353,16 +1501,29 @@
         EXTENT_ITEM* newei;
         
         if (ei->refcount == erv0->count) {
-            delete_tree_item(Vcb, &tp, rollback);
-            delete_tree_item(Vcb, &tp2, rollback);
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
             
+            Status = delete_tree_item(Vcb, &tp2);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
+            }
+            
             if (!superseded)
-                add_checksum_entry(Vcb, address, size / Vcb->superblock.sector_size, NULL, Irp, rollback);
+                add_checksum_entry(Vcb, address, size / Vcb->superblock.sector_size, NULL, Irp);
             
             return STATUS_SUCCESS;
         }
         
-        delete_tree_item(Vcb, &tp2, rollback);
+        Status = delete_tree_item(Vcb, &tp2);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
         
         newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
         if (!newei) {
@@ -1374,11 +1535,16 @@
 
         newei->refcount -= rc;
         
-        delete_tree_item(Vcb, &tp, rollback);
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
+        }
         
-        if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-            ERR("insert_tree_item failed\n");
-            return STATUS_INTERNAL_ERROR;
+        Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
+            return Status;
         }
         
         return STATUS_SUCCESS;
@@ -1389,7 +1555,7 @@
 }
 
 NTSTATUS decrease_extent_refcount_data(device_extension* Vcb, UINT64 address, UINT64 size, UINT64 root, UINT64 inode,
-                                       UINT64 offset, UINT32 refcount, BOOL superseded, PIRP Irp, LIST_ENTRY* rollback) {
+                                       UINT64 offset, UINT32 refcount, BOOL superseded, PIRP Irp) {
     EXTENT_DATA_REF edr;
     
     edr.root = root;
@@ -1397,16 +1563,16 @@
     edr.offset = offset;
     edr.count = refcount;
     
-    return decrease_extent_refcount(Vcb, address, size, TYPE_EXTENT_DATA_REF, &edr, NULL, 0, 0, superseded, Irp, rollback);
+    return decrease_extent_refcount(Vcb, address, size, TYPE_EXTENT_DATA_REF, &edr, NULL, 0, 0, superseded, Irp);
 }
 
 NTSTATUS decrease_extent_refcount_tree(device_extension* Vcb, UINT64 address, UINT64 size, UINT64 root,
-                                       UINT8 level, PIRP Irp, LIST_ENTRY* rollback) {
+                                       UINT8 level, PIRP Irp) {
     TREE_BLOCK_REF tbr;
     
     tbr.offset = root;
     
-    return decrease_extent_refcount(Vcb, address, size, TYPE_TREE_BLOCK_REF, &tbr, NULL/*FIXME*/, level, 0, FALSE, Irp, rollback);
+    return decrease_extent_refcount(Vcb, address, size, TYPE_TREE_BLOCK_REF, &tbr, NULL/*FIXME*/, level, 0, FALSE, Irp);
 }
 
 static UINT64 find_extent_data_refcount(device_extension* Vcb, UINT64 address, UINT64 size, UINT64 root, UINT64 objid, UINT64 offset, PIRP Irp) {
@@ -1529,7 +1695,7 @@
         return eiv0->refcount;
     } else if (tp.item->size < sizeof(EXTENT_ITEM)) {
         ERR("(%llx,%x,%llx) was %x bytes, expected at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type,
-                                                                       tp.item->key.offset, tp.item->size, sizeof(EXTENT_DATA));
+                                                                       tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return 0;
     }
     
@@ -1706,7 +1872,7 @@
         return 0;
     else if (tp.item->size < sizeof(EXTENT_ITEM)) {
         ERR("(%llx,%x,%llx) was %x bytes, expected at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type,
-                                                                   tp.item->key.offset, tp.item->size, sizeof(EXTENT_DATA));
+                                                                   tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return 0;
     }
     
@@ -1747,7 +1913,7 @@
         return;
     else if (tp.item->size < sizeof(EXTENT_ITEM)) {
         ERR("(%llx,%x,%llx) was %x bytes, expected at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type,
-                                                                   tp.item->key.offset, tp.item->size, sizeof(EXTENT_DATA));
+                                                                   tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return;
     }
     
Index: drivers/filesystems/btrfs/fastio.c
===================================================================
--- drivers/filesystems/btrfs/fastio.c	(révision 74430)
+++ drivers/filesystems/btrfs/fastio.c	(copie de travail)
@@ -1,4 +1,4 @@
-/* Copyright (c) Mark Harmstone 2016
+/* Copyright (c) Mark Harmstone 2016-17
  * 
  * This file is part of WinBtrfs.
  * 
@@ -19,14 +19,6 @@
 
 FAST_IO_DISPATCH FastIoDispatch;
 
-static void STDCALL acquire_file_for_create_section(PFILE_OBJECT FileObject) {
-    TRACE("STUB: acquire_file_for_create_section\n");
-}
-
-static void STDCALL release_file_for_create_section(PFILE_OBJECT FileObject) {
-    TRACE("STUB: release_file_for_create_section\n");
-}
-
 static BOOLEAN STDCALL fast_query_basic_info(PFILE_OBJECT FileObject, BOOLEAN wait, PFILE_BASIC_INFORMATION fbi,
                                              PIO_STATUS_BLOCK IoStatus, PDEVICE_OBJECT DeviceObject) {
     fcb* fcb;
@@ -131,7 +123,7 @@
 
         fsi->AllocationSize.QuadPart = fsi->EndOfFile.QuadPart = adssize;
         fsi->NumberOfLinks = fcb->inode_item.st_nlink;
-        fsi->Directory = S_ISDIR(fcb->inode_item.st_mode);
+        fsi->Directory = FALSE;
     } else {
         fsi->AllocationSize.QuadPart = S_ISDIR(fcb->inode_item.st_mode) ? 0 : sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size);
         fsi->EndOfFile.QuadPart = S_ISDIR(fcb->inode_item.st_mode) ? 0 : fcb->inode_item.st_size;
@@ -151,12 +143,6 @@
     return TRUE;
 }
 
-static BOOLEAN STDCALL fast_io_query_open(PIRP Irp, PFILE_NETWORK_OPEN_INFORMATION  NetworkInformation, PDEVICE_OBJECT DeviceObject) {
-    TRACE("STUB: fast_io_query_open\n");
-    
-    return FALSE;
-}
-
 static BOOLEAN STDCALL fast_io_check_if_possible(PFILE_OBJECT FileObject, PLARGE_INTEGER FileOffset, ULONG Length, BOOLEAN Wait,
                                          ULONG LockKey, BOOLEAN CheckForReadOperation, PIO_STATUS_BLOCK IoStatus,
                                          PDEVICE_OBJECT DeviceObject) {
@@ -178,40 +164,56 @@
     return FALSE;
 }
 
-static BOOLEAN STDCALL fast_io_lock(PFILE_OBJECT FileObject, PLARGE_INTEGER FileOffset, PLARGE_INTEGER Length, PEPROCESS ProcessId, ULONG Key, BOOLEAN FailImmediately, BOOLEAN ExclusiveLock, PIO_STATUS_BLOCK IoStatus, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_lock\n");
-    return FALSE;
+static BOOLEAN STDCALL fast_io_query_network_open_info(PFILE_OBJECT FileObject, BOOLEAN Wait, FILE_NETWORK_OPEN_INFORMATION* fnoi,
+                                                       PIO_STATUS_BLOCK IoStatus, PDEVICE_OBJECT DeviceObject) {
+    INODE_ITEM* ii;
+    fcb* fcb;
+    ccb* ccb;
+    file_ref* fileref;
+    
+    TRACE("(%p, %u, %p, %p, %p)\n", FileObject, Wait, fnoi, IoStatus, DeviceObject);
+    
+    RtlZeroMemory(fnoi, sizeof(FILE_NETWORK_OPEN_INFORMATION));
+    
+    fcb = FileObject->FsContext;
+    
+    if (!fcb || fcb == fcb->Vcb->volume_fcb)
+        return FALSE;
+    
+    ccb = FileObject->FsContext2;
+    
+    if (!ccb)
+        return FALSE;
+    
+    fileref = ccb->fileref;
+    
+    if (fcb->ads) {
+        if (!fileref || !fileref->parent) {
+            ERR("no fileref for stream\n");
+            return FALSE;
+        }
+        
+        ii = &fileref->parent->fcb->inode_item;
+    } else
+        ii = &fcb->inode_item;
+    
+    fnoi->CreationTime.QuadPart = unix_time_to_win(&ii->otime);
+    fnoi->LastAccessTime.QuadPart = unix_time_to_win(&ii->st_atime);
+    fnoi->LastWriteTime.QuadPart = unix_time_to_win(&ii->st_mtime);
+    fnoi->ChangeTime.QuadPart = unix_time_to_win(&ii->st_ctime);
+    
+    if (fcb->ads) {
+        fnoi->AllocationSize.QuadPart = fnoi->EndOfFile.QuadPart = fcb->adsdata.Length;
+        fnoi->FileAttributes = fileref->parent->fcb->atts;
+    } else {
+        fnoi->AllocationSize.QuadPart = S_ISDIR(fcb->inode_item.st_mode) ? 0 : sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size);
+        fnoi->EndOfFile.QuadPart = S_ISDIR(fcb->inode_item.st_mode) ? 0 : fcb->inode_item.st_size;
+        fnoi->FileAttributes = fcb->atts;
+    }
+    
+    return TRUE;
 }
 
-static BOOLEAN STDCALL fast_io_unlock_single(PFILE_OBJECT FileObject, PLARGE_INTEGER FileOffset, PLARGE_INTEGER Length, PEPROCESS ProcessId, ULONG Key, PIO_STATUS_BLOCK IoStatus, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_unlock_single\n");
-    return FALSE;
-}
-
-static BOOLEAN STDCALL fast_io_unlock_all(PFILE_OBJECT FileObject, PEPROCESS ProcessId, PIO_STATUS_BLOCK IoStatus, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_unlock_all\n");
-    return FALSE;
-}
-
-static BOOLEAN STDCALL fast_io_unlock_all_by_key(PFILE_OBJECT FileObject, PVOID ProcessId, ULONG Key, PIO_STATUS_BLOCK IoStatus, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_unlock_all_by_key\n");
-    return FALSE;
-}
-
-static BOOLEAN STDCALL fast_io_device_control(PFILE_OBJECT FileObject, BOOLEAN Wait, PVOID InputBuffer OPTIONAL, ULONG InputBufferLength, PVOID OutputBuffer OPTIONAL, ULONG OutputBufferLength, ULONG IoControlCode, PIO_STATUS_BLOCK IoStatus, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_device_control\n");
-    return FALSE;
-}
-
-static VOID STDCALL fast_io_detach_device(PDEVICE_OBJECT SourceDevice, PDEVICE_OBJECT TargetDevice){
-    TRACE("STUB: fast_io_detach_device\n");
-}
-
-static BOOLEAN STDCALL fast_io_query_network_open_info(PFILE_OBJECT FileObject, BOOLEAN Wait, struct _FILE_NETWORK_OPEN_INFORMATION *Buffer, struct _IO_STATUS_BLOCK *IoStatus, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_query_network_open_info\n");
-    return FALSE;
-}
-
 static NTSTATUS STDCALL fast_io_acquire_for_mod_write(PFILE_OBJECT FileObject, PLARGE_INTEGER EndingOffset, struct _ERESOURCE **ResourceToRelease, PDEVICE_OBJECT DeviceObject) {
     fcb* fcb;
     
@@ -230,38 +232,34 @@
     return STATUS_SUCCESS;
 }
 
-static BOOLEAN STDCALL fast_io_read_compressed(PFILE_OBJECT FileObject, PLARGE_INTEGER FileOffset, ULONG Length, ULONG LockKey, PVOID Buffer, PMDL *MdlChain, PIO_STATUS_BLOCK IoStatus, struct _COMPRESSED_DATA_INFO *CompressedDataInfo, ULONG CompressedDataInfoLength, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_read_compressed\n");
-    return FALSE;
+static NTSTATUS STDCALL fast_io_release_for_mod_write(PFILE_OBJECT FileObject, struct _ERESOURCE *ResourceToRelease, PDEVICE_OBJECT DeviceObject) {
+    TRACE("(%p, %p, %p)\n", FileObject, ResourceToRelease, DeviceObject);
+    
+    ExReleaseResourceLite(ResourceToRelease);
+    
+    return STATUS_SUCCESS;
 }
 
-static BOOLEAN STDCALL fast_io_write_compressed(PFILE_OBJECT FileObject, PLARGE_INTEGER FileOffset, ULONG Length, ULONG LockKey, PVOID Buffer, PMDL *MdlChain, PIO_STATUS_BLOCK IoStatus, struct _COMPRESSED_DATA_INFO *CompressedDataInfo, ULONG CompressedDataInfoLength, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_write_compressed\n");
-    return FALSE;
-}
-
-static BOOLEAN STDCALL fast_io_mdl_read_complete_compressed(PFILE_OBJECT FileObject, PMDL MdlChain, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_mdl_read_complete_compressed\n");
-    return FALSE;
-}
-
-static BOOLEAN STDCALL fast_io_mdl_write_complete_compressed(PFILE_OBJECT FileObject, PLARGE_INTEGER FileOffset, PMDL MdlChain, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_mdl_write_complete_compressed\n");
-    return FALSE;
-}
-
-static NTSTATUS STDCALL fast_io_release_for_mod_write(PFILE_OBJECT FileObject, struct _ERESOURCE *ResourceToRelease, PDEVICE_OBJECT DeviceObject){
-    TRACE("STUB: fast_io_release_for_mod_write\n");
-    return STATUS_NOT_IMPLEMENTED;
-}
-
-static NTSTATUS STDCALL fast_io_acquire_for_ccflush(PFILE_OBJECT FileObject, PDEVICE_OBJECT DeviceObject){
+static NTSTATUS STDCALL fast_io_acquire_for_ccflush(PFILE_OBJECT FileObject, PDEVICE_OBJECT DeviceObject) {
     TRACE("STUB: fast_io_acquire_for_ccflush\n");
+    
+    UNUSED(FileObject);
+    UNUSED(DeviceObject);
+    
+    IoSetTopLevelIrp((PIRP)FSRTL_CACHE_TOP_LEVEL_IRP);
+    
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS STDCALL fast_io_release_for_ccflush(PFILE_OBJECT FileObject, PDEVICE_OBJECT DeviceObject){
+static NTSTATUS STDCALL fast_io_release_for_ccflush(PFILE_OBJECT FileObject, PDEVICE_OBJECT DeviceObject) {
     TRACE("STUB: fast_io_release_for_ccflush\n");
+    
+    UNUSED(FileObject);
+    UNUSED(DeviceObject);
+    
+    if (IoGetTopLevelIrp() == (PIRP)FSRTL_CACHE_TOP_LEVEL_IRP)
+        IoSetTopLevelIrp(NULL);
+
     return STATUS_SUCCESS;
 }
 
@@ -320,21 +318,15 @@
     FastIoDispatch.FastIoCheckIfPossible = fast_io_check_if_possible;
     FastIoDispatch.FastIoQueryBasicInfo = fast_query_basic_info;
     FastIoDispatch.FastIoQueryStandardInfo = fast_query_standard_info;
-    FastIoDispatch.FastIoLock = fast_io_lock;
-    FastIoDispatch.FastIoUnlockSingle = fast_io_unlock_single;
-    FastIoDispatch.FastIoUnlockAll = fast_io_unlock_all;
-    FastIoDispatch.FastIoUnlockAllByKey = fast_io_unlock_all_by_key;
-    FastIoDispatch.FastIoDeviceControl = fast_io_device_control;
-    FastIoDispatch.AcquireFileForNtCreateSection = acquire_file_for_create_section;
-    FastIoDispatch.ReleaseFileForNtCreateSection = release_file_for_create_section;
-    FastIoDispatch.FastIoDetachDevice = fast_io_detach_device;
+//     FastIoDispatch.FastIoLock = fast_io_lock;
+//     FastIoDispatch.FastIoUnlockSingle = fast_io_unlock_single;
+//     FastIoDispatch.FastIoUnlockAll = fast_io_unlock_all;
+//     FastIoDispatch.FastIoUnlockAllByKey = fast_io_unlock_all_by_key;
+//     FastIoDispatch.FastIoDeviceControl = fast_io_device_control;
+//     FastIoDispatch.AcquireFileForNtCreateSection = acquire_file_for_create_section;
+//     FastIoDispatch.ReleaseFileForNtCreateSection = release_file_for_create_section;
     FastIoDispatch.FastIoQueryNetworkOpenInfo = fast_io_query_network_open_info;
     FastIoDispatch.AcquireForModWrite = fast_io_acquire_for_mod_write;
-    FastIoDispatch.FastIoReadCompressed = fast_io_read_compressed;
-    FastIoDispatch.FastIoWriteCompressed = fast_io_write_compressed;
-    FastIoDispatch.MdlReadCompleteCompressed = fast_io_mdl_read_complete_compressed;
-    FastIoDispatch.MdlWriteCompleteCompressed = fast_io_mdl_write_complete_compressed;
-    FastIoDispatch.FastIoQueryOpen = fast_io_query_open;
     FastIoDispatch.ReleaseForModWrite = fast_io_release_for_mod_write;
     FastIoDispatch.AcquireForCcFlush = fast_io_acquire_for_ccflush;
     FastIoDispatch.ReleaseForCcFlush = fast_io_release_for_ccflush;
